<bugID>1017320<Summary>[e10s] [meta] Compatibility shims for add-ons</Summary><Description>This bug is about running add-ons in a virtualized environment that will make e10s Firefox look more like single-process Firefox. Examples of this:

1. Accessing browser.contentWindow in normal Firefox code will be an error (even when e10s is enabled), while in an add-on it will return a cross-process wrapper around the content document.
2. Calling window.addEventListener("pageshow") from an add-on will send a request to all child processes asking that pageshow events be forwarded to the parent process so that they can be given to add-ons. Normal Firefox chrome code will never see these events, and they won't be forwarded unless add-ons ask for them.
3. Calling Services.obs.addObserver(..., "content-document-global-created", ...) will send a message to the child asking it to forward these observer notifications to the parent, similar to above.

Similar things will need to happen with the category manager and all the other places where an add-on can ask for notifications about activity in content.</Description></bugID>